package CH.ifa.draw.application;

import java.io.FilenameFilter;
import java.io.File;
import de.renew.util.StringUtil;

/**
 * FileByExtensionFilter.java
 *
 *
 * Created: Wed Apr 19  2000
 * Modified: Mon May 15  2000
 *
 * @author Michael Duvigneau
 * @author Frank Wienberg
 */

public class FileByExtensionFilter implements FilenameFilter {
  
  private String[] extensions;

  public FileByExtensionFilter(String[] extensions) {
    if (extensions.length == 0) 
      extensions = null;
    this.extensions = extensions;
  }

  public boolean accept(File dir, String name) {
    if (extensions==null) {
      return true;
    } else {
      String ext=StringUtil.getExtension(name);
      for (int i = 0; i < extensions.length; i++) {
	  if (extensions[i].equals(name)) {
	      return true;
	  }
      }
      return false;
    }
  }

}
