package de.renew.formalism.java;

import de.renew.simulator.*;
import de.renew.expression.Expression;
import de.renew.shadow.*;
import de.renew.util.Types;

public class SimpleArcFactory implements ArcFactory {
  private int arcType;
  
  public SimpleArcFactory(int arcType) {
    this.arcType=arcType;
  }

  public void emptyArcCheck() {}

  public void compileArc(Place place, Transition transition, boolean trace,
    Class placeType, TypedExpression typedExpr) throws SyntaxException
  {
    Expression expr;
    if (arcType==Arc.out) {
      expr=JavaNetHelper.makeCastedOutputExpression(placeType,typedExpr);
    } else {
      expr=JavaNetHelper.makeCastedInputExpression(placeType,typedExpr);
    }
  
    Arc arc=new Arc(place,arcType,expr);
    arc.setTrace(trace);
    transition.add(arc);
  }
}
