/*
 * @(#)AnimateCommand.java 5.1
 *
 */

package de.renew.gui;

import java.util.*;
import CH.ifa.draw.util.Command;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.*;

/**
 * Command to start/stop animating a drawing.
 *
 * @see Animatable
 * @see Animator
 */
public class AnimateCommand extends Command {

    protected DrawingEditor fEditor;
    protected Animator      fAnimator=null; // animator object

   /**
    * Constructs an animate command.
    * @param name the command name
    * @param view the target editor
    */
    public AnimateCommand(String name, DrawingEditor editor) {
        super(name);
        fEditor = editor;
    }

    public void execute() {
        DrawingView view = fEditor.view();
        Drawing drawing = view.drawing();

	if (fAnimator==null) {
	    fAnimator=new Animator((Animatable)drawing, view);
	    fAnimator.start();
	} else {
	    fAnimator.end();
	    fAnimator = null;
	}
    }

}
