package de.renew.simulator;

import collections.*;
import java.util.*;
import de.renew.unify.*;

public class Binding {
  private CollectionEnumeration executables;
  private String description;

  public Vector occurrences;
  public Vector mappers;

  Binding(Searcher searcher) {
    executables=searcher.makeExecutables();
    StringBuffer descr=new StringBuffer();

    occurrences=new Vector();
    mappers=new Vector();

    CollectionEnumeration enum=searcher.getOccurrences();
    while (enum.hasMoreElements()) {
      TransitionOccurrence occurrence=
	(TransitionOccurrence)enum.nextElement();
      descr.append(occurrence.toString());

      occurrences.addElement(occurrence);
      mappers.addElement(
        occurrence.getMapper().makeCopy(new Copier()));

      if (enum.hasMoreElements()) {
	descr.append(", ");
      }
    }
  
    description=descr.toString();
  }

  public boolean execute(final Tracer tracer, final boolean asynchronous) {
    if (executables==null) {
      throw new RuntimeException("Cannot execute binding twice.");
    }
    CollectionEnumeration exe=executables;
    executables=null;
    return SimulatorHelper.execute(exe,tracer,asynchronous);
  }

  public String toString() {
    return description;
  }

  public Enumeration getOccurrences() {
      return occurrences.elements();
  }

  public Enumeration getMappers() {
      return mappers.elements();
  }

}


