package de.renew.simulator;

import collections.*;
import de.renew.unify.*;
import java.util.Enumeration;

public class ExecuteFinder implements Finder {
  private CollectionEnumeration executables=null;

  public ExecuteFinder() {}
  
  public void found(Searcher searcher) {
    if (executables!=null) {
      throw new RuntimeException("ExecuteFinder was reused.");
    }
    executables=searcher.makeExecutables();
  }

  public boolean isCompleted() {
    return executables!=null;
  }

  public boolean execute(final Tracer tracer, final boolean asynchronous) {
    boolean result=SimulatorHelper.execute(executables,tracer,asynchronous);
    executables=null;
    return result;
  }
}
