package de.renew.simulator;

public class InhibitorTokenCollector implements TokenCollector {
  private PlaceInstance instance;
  
  public InhibitorTokenCollector(PlaceInstance instance) {
    this.instance=instance;
  }

  // An inhibitor token collector has to verify that a token
  // is not available. Hence the method name is misleading 
  // and should be changed.
  public boolean containsToken(Object token) {
    // I ask the place instance directly, not the reserver object,
    // because it is required that the place does not contain 
    // the token before other arcs have made their reservations.
    return !instance.containsTestableToken(token);
  }

  public boolean collectToken(Object token) {
    // Nothing to do, really.
    return containsToken(token);
  }

  public void freeToken(Object token) {
    // Nothing to do.
  }
  
  public void registerAt(Searcher searcher) {
    searcher.insertTriggerable(instance.triggerables());
  }
}
